import sys
from pathlib import Path
from unittest.mock import MagicMock

import pytest
import requests


@pytest.fixture
def mocked_responses():
    import responses

    with responses.RequestsMock() as rsps:
        yield rsps


@pytest.fixture
def gpio(monkeypatch):
    pio = MagicMock()
    monkeypatch.setitem(sys.modules, "RPi.GPIO", pio)
    get_req = MagicMock()
    monkeypatch.setattr(requests, "get", get_req)
    return pio, get_req


@pytest.fixture
def fixture_path():
    return Path(__file__).parent / "test-fixtures"


@pytest.fixture
def client():
    from parkpow_gate_opener import app

    with app.test_client() as client:
        yield client
